#
# ImportForm.rb
#
# Copyright 2005 Tero Hasu
#

module ChaosOrder
  # Reads the order form data from the specified file,
  # but does not attempt parsing it.
  def self.get_form_data_from_file(file)
    case file
    when /\.exe$/i
      require 'strscan'
      ss = StringScanner.new(File.read(file))
      unless ss.skip_until(/PK\003\004/)
        raise "no zip signature found"
      end
      # already read the file but unfortunately
      # the zip library seems to want to read it, too;
      # at least it allows us to specify the position
      return get_zip_entry_data(file, ss.pos)
    when /\.zip$/i
      return get_zip_entry_data(file, 0)
    else
      return File.read(file)
    end
  end

  def self.get_zip_entry_data(zipfile, offset)
    require 'zip/zip'
    input = Zip::ZipInputStream.new(zipfile, offset)
    begin
      loop do
        entry = input.get_next_entry
        break unless entry
        if entry.name =~ /\.asc$/
          return input.read
        end
      end
    ensure
      input.close
    end
    raise "could not find .asc entry from zip"
  end
end

if $0 == __FILE__
  #require 'strscan'
  #ss = StringScanner.new(File.read(__FILE__))
  #ss.skip_until(/__FILE__/)
  #p ss.pos
  #p ss.rest
  #p ss.rest?
  #p ss.rest

  Dir['/tmp/dia*.zip'].each do |file|
    puts ChaosOrder.get_form_data_from_file(file)
  end
end
