#
# WriteOrder.rb
#
# Copyright 2005 Tero Hasu
#

begin
  require 'customer'
rescue LoadError
  warn %{
Create a file named customer.rb with your info.
Using customer-sample.rb for now.
}
  require 'customer-sample'
end

require 'erb'

module ChaosOrder
  NEWLINE = "\n"

  def self.write_order(output, model)
    text = %{
<%= $customer_number %>
<%= $customer_name %>
<%= $customer_street1 %>
<%= $customer_street2 %>
<%= $customer_town %>, <%= $customer_country %> , <%= $customer_pcode %>
<%= $customer_tel %>
<%= $customer_email %>
TAB}
    header = ERB.new(text.strip).result()
    header = header.gsub(/\r?\n/, NEWLINE) + NEWLINE * 2
    output.write(header)

    for item in model.select_ordered
      output.write(item.to_order_line)
      output.write(NEWLINE)
    end
  end
end

if $0 == __FILE__
  $LOAD_PATH.push(File.dirname(File.expand_path(__FILE__)))
  file = ARGV.shift || '../forms/form-2004_03.ord'
  require 'ImportForm'
  data = ChaosOrder::get_form_data_from_file(file)
  require 'ParseForm'
  parser = ChaosOrder::OrderFormParser.new
  parser.parse(data)
  require 'OrderModel'
  model = ChaosOrder::OrderModel.new(parser.items)
  ChaosOrder::write_order($stdout, model)
end
